// postoffice filter for chrome by H.Shirouzu

$ = function(id) { return document.getElementById(id); }
var pf_opt = {};
var pf_flags = 0;

function pf_convert(saved_pf_opt) {
	if (!saved_pf_opt.id1) {
		return;
	}
	for (var i=0; i < 3; i++) {
		saved_pf_opt["pf_okyakusamaBangou" + i] = saved_pf_opt["id" + i];
	}
	pf_save(function(){});
}

function pf_load(cb) {
    chrome.storage.local.get("pf_opt",
    	function(res) {
	        if (res.pf_opt) {
				pf_convert(res.pf_opt);
				for (var key in res.pf_opt) {
					pf_opt[key] = res.pf_opt[key];
				}
	        }
	        cb();
		}
    );
}

function pf_save(cb) {
    chrome.storage.local.set({"pf_opt": pf_opt}, cb);
}

function filter_setval(prefix, input_eles) {
    for (var i in input_eles) {
		var ele = input_eles[i];
		var key = store_key(prefix, ele.name);
        if (pf_opt[key]) {
            ele.ele.value = pf_opt[key];
        }
    }
}

function store_key(prefix, key) {
	if (prefix) {
		return	prefix + "_" + key;
	}
	return	key;
}

function filter_proc(prefix, form, input_names, get_ele_func) {
    var input_eles = [];
    for (var i in input_names) {
		var ele = get_ele_func(input_names[i]);
		if (ele) {
			input_eles.push({"ele": ele, "name": input_names[i]});
		}
	}

    if (!input_eles) {
        return;
    }

    var next = get_ele_func(form);
    if (next) {
        document.addEventListener('click',
        	function() {
				var need_save = false;
				var obj = next;
				if (obj) {
					obj;
				}
				for (var i in input_eles) {
					var ele = input_eles[i];
					if (ele.ele.value != pf_opt[store_key(prefix, ele.name)]) {
		                pf_opt[store_key(prefix, ele.name)] = ele.ele.value;
		                if (ele.ele.value) {
			                need_save = true;
			            }
			        }
	            }
	            if (need_save) {
	                pf_save(function() {});
	            }
		    }, true);
    }
    pf_load(
    	function() {
			filter_setval(prefix, input_eles);
		}
	);
}

function autocomplete_proc(name, get_ele_func) {
    var eles = get_ele_func(name);
    for (var i=0; i < eles.length; i++) {
	    eles[i].autocomplete="on";
	}
}

function get_ele_by_name(name) {
	return	document.getElementsByName(name)[0];
}

// ターゲットnodeにid も名前もない
function get_submit_name_for_moneykit() {
	var eles = document.getElementsByTagName('img');
	var targ = '/img/login.gif';

	for(var i = 0; i < eles.length; i++) {
	    if(eles[i].src.substr(- targ.length) == targ) {
			var parent = eles[i].parentNode;
			if (parent) {
				if (!parent.name) {
					parent.name = "moneykit_login_submit_name";
				}
				return	parent.name;
			}
	    }
	}
	return	false;
}

// ターゲットnodeにid も名前もない
function get_submit_name_for_mizuho() {
	var eles = document.getElementsByTagName('input');

	for(var i = 0; i < eles.length; i++) {
	    if(eles[i].type.toLowerCase() == 'submit') {
			if (!eles[i].name) {
				eles[i].name = "mizuho_login_submit_name";
			}
			return	eles[i].name;
	    }
	}
	return	false;
}

function main_proc()
{
    if (location.href.match(/direct\.jp-bank\.japanpost\.jp\/tp1web\/U010101SCK\.do.*/i) ||
        location.href.match(/direct\.jp-bank\.japanpost\.jp\/tp1web\/U010101WAK\.do.*/i)) {
		var	get_func = get_ele_by_name;
		filter_proc("pf",
					"U010103",
					(pf_flags & 1) ?
						["okyakusamaBangou1", "okyakusamaBangou2"] :
						["okyakusamaBangou1", "okyakusamaBangou2", "okyakusamaBangou3"],
					get_func);
	//	autocomplete_proc("submitData", get_func);
    }
	else if (pf_flags & 1) {
		return;
	}
	else if (location.href.match(/direct\.smbc\.co\.jp\/aib\/aibgsjsw5001\.jsp.*/i)) {
		var	get_func = get_ele_by_name;
		filter_proc("smbc",
					"bLogon.y",
					["S_BRANCH_CD", "USRID1"],
					get_func);
	//	autocomplete_proc("Login", get_func);
    }
	else if (location.href.match(/bk02\.jibunbank\.co\.jp\/ibretail\/RetailLogin\.html.*/i)) {
		var	get_func = $;
		filter_proc("jibun",
					"idLogon",
					["number1"],
					get_func);
	//	autocomplete_proc("form1", get_func);
    }
	else if (location.href.match(/o2o\.moneykit\.net\/NBG100001G01\.html.*/i)) {
		var	get_func = get_ele_by_name;
		var name = get_submit_name_for_moneykit();
		filter_proc("moneykit",
					name,
					["TenNo"],
					get_func);
 	//	autocomplete_proc("HOST", get_func);
    }
	else if (location.href.match(/web\.ib\.mizuhobank\.co\.jp\/servlet\/LOGBNK0000000B\.do.*/i)) {
		var	get_func = get_ele_by_name;
		var name = get_submit_name_for_mizuho();
		if (name) {
			filter_proc("mizuho",
						name,
						["txbCustNo"],
						get_func);
		}
	//	autocomplete_proc("txbCustNo", get_func);
    }
}

function pf_load_flags(res) {
	if (res.pf_flags) {
		pf_flags = res.pf_flags;
	}
	else {
		pf_flags = 0;
	}
	main_proc();
}


function start_proc() {
    chrome.storage.local.get("pf_flags", pf_load_flags);
}

start_proc();

