// postoffice filter for chrome by H.Shirouzu
$ = function(id) { return document.getElementById(id); }

var saved_name =
	"ゆうちょ銀行「お客様番号（全て）」\n" +
	"三井住友銀行「契約者番号（前半部）」or「店番号」\n" +
	"みずほ銀行「お客様番号」\n" +
	"じぶん銀行「お客様番号（前半部）」\n" +
	"ソニー銀行「店番号」\n";

function pf_cache_disabled() {
    $("cache_del").disabled = true;
	$("cache_state").innerText = "ログイン用ID類は保存されていません";
}

function pf_cache_clear() {
    chrome.storage.local.clear(function() {
    	alert("記憶した\n" + saved_name + "をクリアしました");
    });
    pf_cache_disabled();
}

function pf_strict_check(res) {
	var check = (res.pf_flags && (res.pf_flags & 1)) ? false : true;
	if (check) {
		res.pf_flags |= 0x1;
		if ($("cache_del").disabled != true) {
			alert("「記憶したログイン用ID類を全て削除」も実施したほうが安全です。");
		}
	}
	else {
		res.pf_flags &= ~0x1;
	}
    chrome.storage.local.set({"pf_flags": res.pf_flags}, function(){});
	$("strict_check").checked = check;
}

function pf_strict() {
    chrome.storage.local.get("pf_flags", pf_strict_check);
}

function pf_load(res) {
    if (res && res.pf_opt) {
	    $("cache_del").onclick  = pf_cache_clear;
	}
	else {
		pf_cache_disabled();
	}
}

function pf_load_flags(res) {
	$("strict_check").checked = (res.pf_flags && (res.pf_flags & 1)) ? true : false;
    $("strict_check").onclick = pf_strict;
}

function pf_init() {
    chrome.storage.local.get("pf_opt", pf_load);
    chrome.storage.local.get("pf_flags", pf_load_flags);
}

window.onload = function() {
    pf_init();
}

